diff --git a/docs/build/latex/ncclient.toc b/docs/build/latex/ncclient.toc
new file mode 100644
index 0000000..12a60cc
--- /dev/null
+++ b/docs/build/latex/ncclient.toc
@@ -0,0 +1,34 @@
+\select@language {english}
+\contentsline {chapter}{\numberline {1}Introduction}{1}{chapter.1}
+\contentsline {chapter}{\numberline {2}User documentation}{3}{chapter.2}
+\contentsline {section}{\numberline {2.1}\texttt {manager} module}{3}{section.2.1}
+\contentsline {subsection}{\numberline {2.1.1}Dealing with RPC errors}{3}{subsection.2.1.1}
+\contentsline {subsection}{\numberline {2.1.2}Manager instances}{3}{subsection.2.1.2}
+\contentsline {section}{\numberline {2.2}\texttt {capabilities} module}{4}{section.2.2}
+\contentsline {section}{\numberline {2.3}\texttt {content} module}{5}{section.2.3}
+\contentsline {subsection}{\numberline {2.3.1}Namespaces}{5}{subsection.2.3.1}
+\contentsline {subsection}{\numberline {2.3.2}DictTree XML representation}{5}{subsection.2.3.2}
+\contentsline {subsection}{\numberline {2.3.3}Converting between different representations}{5}{subsection.2.3.3}
+\contentsline {subsection}{\numberline {2.3.4}Other utility functions}{6}{subsection.2.3.4}
+\contentsline {subsection}{\numberline {2.3.5}Errors}{7}{subsection.2.3.5}
+\contentsline {section}{\numberline {2.4}\texttt {transport} module}{7}{section.2.4}
+\contentsline {subsection}{\numberline {2.4.1}Base types}{7}{subsection.2.4.1}
+\contentsline {subsection}{\numberline {2.4.2}SSH session implementation}{7}{subsection.2.4.2}
+\contentsline {subsection}{\numberline {2.4.3}Errors}{8}{subsection.2.4.3}
+\contentsline {section}{\numberline {2.5}\texttt {operations} module}{9}{section.2.5}
+\contentsline {subsection}{\numberline {2.5.1}Base types}{9}{subsection.2.5.1}
+\contentsline {subsection}{\numberline {2.5.2}NETCONF Operations}{10}{subsection.2.5.2}
+\contentsline {subsubsection}{Dependencies}{10}{subsubsection*.2}
+\contentsline {subsubsection}{Return type}{10}{subsubsection*.3}
+\contentsline {subsubsection}{General notes on parameters}{10}{subsubsection*.4}
+\contentsline {paragraph}{Source / target parameters}{10}{paragraph*.5}
+\contentsline {paragraph}{Filter parameters}{10}{paragraph*.6}
+\contentsline {subsubsection}{Retrieval operations}{10}{subsubsection*.7}
+\contentsline {subsubsection}{Locking operations}{11}{subsubsection*.8}
+\contentsline {subsubsection}{Configuration operations}{11}{subsubsection*.9}
+\contentsline {subsubsection}{Session management operations}{12}{subsubsection*.10}
+\contentsline {subsubsection}{Also useful}{13}{subsubsection*.11}
+\contentsline {subsection}{\numberline {2.5.3}Errors}{13}{subsection.2.5.3}
+\contentsline {chapter}{\numberline {3}Extending NCClient}{15}{chapter.3}
+\contentsline {chapter}{Module Index}{17}{section*.12}
+\contentsline {chapter}{Index}{19}{section*.13}
diff --git a/docs/build/latex/python.ist b/docs/build/latex/python.ist
new file mode 100644
index 0000000..9ffa0f9
--- /dev/null
+++ b/docs/build/latex/python.ist
@@ -0,0 +1,11 @@
+line_max 100
+headings_flag 1
+heading_prefix "  \\bigletter "
+
+preamble "\\begin{theindex}
+\\def\\bigletter#1{{\\Large\\sffamily#1}\\nopagebreak\\vspace{1mm}}
+
+"
+
+symhead_positive "{Symbols}"
+numhead_positive "{Numbers}"
diff --git a/ncclient/__init__.py b/ncclient/__init__.py
index 95966cd..61bb4ff 100644
--- a/ncclient/__init__.py
+++ b/ncclient/__init__.py
@@ -12,19 +12,12 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-'''
-TODO
-=====
-* code freeze and reST doc
-'''
-
 import sys
 
 # actually no reason why shouldn't work on 2.5 but that's... untested -- TODO
 if sys.version_info < (2, 6):
     raise RuntimeError('You need Python 2.6+ for this module.')
 
-__version__ = "0.05"
-
 class NCClientError(Exception):
+    "Base type for all NCClient errors"
     pass
diff --git a/ncclient/capabilities.py b/ncclient/capabilities.py
index 6e1f78d..bf730ed 100644
--- a/ncclient/capabilities.py
+++ b/ncclient/capabilities.py
@@ -12,36 +12,53 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-def abbreviate(uri):
-    if uri.startswith('urn:ietf:params:netconf:capability:'):
-        return ':' + uri.split(':')[5]
-    elif uri.startswith('urn:ietf:params:netconf:base:'):
-        return ':base'
-
-def version(uri):
-    if uri.startswith('urn:ietf:params:netconf:capability:'):
-        return uri.split(':')[6]
-    elif uri.startswith('urn:ietf:params:netconf:base:'):
-        return uri.split(':')[5]
+def _abbreviate(uri):
+    if uri.startswith('urn:ietf:params:netconf:'):
+        splitted = uri.split(':')
+        if ':capability:' in uri:
+            return [ ':' + splitted[5], ':' + splitted[5] + ':' + splitted[6] ]
+        elif ':base:' in uri:
+            return [ ':base', ':base' + ':'+ splitted[5] ]
+        else:
+            return []
+    else:
+        return []
+
+def schemes(url_uri):
+    """Given a URI that has a *scheme* query string (i.e. *:url* capability
+    URI), will return a list of supported schemes.
+    """
+    return url_uri.partition("?scheme=")[2].split(',')
 
 class Capabilities:
 
-    def __init__(self, capabilities=None):
+    """Represents the set of capabilities for a NETCONF client or server.
+    Initialised with a list of capability URI's.
+
+    Presence of a capability can be checked with the *in* operations. In addition
+    to the URI, for capabilities of the form
+    *urn:ietf:params:netconf:capability:$name:$version* their shorthand can be
+    used as a key. For example, for
+    *urn:ietf:params:netconf:capability:candidate:1.0* the shorthand would be
+    *:candidate*. If version is significant, use *:candidate:1.0* as key.
+    """
+
+    def __init__(self, capabilities):
         self._dict = {}
-        if isinstance(capabilities, dict):
-            self._dict = capabilities
-        elif isinstance(capabilities, list):
-            for uri in capabilities:
-                self._dict[uri] = (abbreviate(uri), version(uri))
+        for uri in capabilities:
+            self._dict[uri] = _abbreviate(uri)
 
     def __contains__(self, key):
         if key in self._dict:
             return True
-        for info in self._dict.values():
-            if key == info[0]:
+        for abbrs in self._dict.values():
+            if key in abbrs:
                 return True
         return False
 
+    def __len__(self):
+        return len(self._dict)
+
     def __iter__(self):
         return self._dict.keys().__iter__()
 
@@ -51,44 +68,29 @@ class Capabilities:
     def __list__(self):
         return self._dict.keys()
 
-    def add(self, uri, info=None):
-        if info is None:
-            info = (abbreviate(uri), version(uri))
-        self._dict[uri] = info
+    def add(self, uri):
+        "Add a capability"
+        self._dict[uri] = _abbreviate(uri)
 
-    set = add
-
-    def remove(self, key):
+    def remove(self, uri):
+        "Remove a capability"
         if key in self._dict:
             del self._dict[key]
-        else:
-            for uri in self._dict:
-                if key in self._dict[uri]:
-                    del self._dict[uri]
-                    break
-
-    def get_uri(self, shortname):
-        for uri, info in self._dict.items():
-            if info[0] == shortname:
-                return uri
-
-    def url_schemes(self):
-        url_uri = get_uri(':url')
-        if url_uri is None:
-            return []
-        else:
-            return url_uri.partition("?scheme=")[2].split(',')
 
-    def version(self, key):
-        try:
-            return self._dict[key][1]
-        except KeyError:
-            for uri, info in self._dict.items():
-                if info[0] == key:
-                    return info[1]
+    def check(self, key):
+        """Whether specified capability is present.
+
+        :arg key: URI or shorthand
+
+        .. note:
+            The *in* operation is the preferred form.
+        """
+        return key in self
 
+    def get_uris(self, shorthand):
+        return [uri for uri, abbrs in self._dict.items() if shorthand in abbrs]
 
-#: the capabilities supported by NCClient
+#: :class:`Capabilities` object representing the capabilities currently supported by NCClient
 CAPABILITIES = Capabilities([
     'urn:ietf:params:netconf:base:1.0',
     'urn:ietf:params:netconf:capability:writable-running:1.0',
diff --git a/ncclient/content.py b/ncclient/content.py
index 9685514..6b92110 100644
--- a/ncclient/content.py
+++ b/ncclient/content.py
@@ -159,9 +159,10 @@ xml2ele = XML.Element
 iselement = ET.iselement
 
 def find(ele, tag, nslist=[]):
-    """If `nslist` is empty, same as :meth:`xml.etree.ElementTree.Element.find`. If it is not, `tag` is interpreted as an unqualified name and qualified using each item in `nslist`. The first match is returned.
+    """If *nslist* is empty, same as :meth:`xml.etree.ElementTree.Element.find`. If it is not, *tag* is interpreted as an unqualified name and qualified using each item in *nslist* (with a :const:`None` item in *nslit* meaning no qualification is done). The first match is returned.
 
     :arg nslist: optional list of namespaces
+    :type nslit: `string` `list`
     """
     if nslist:
         for qname in multiqualify(tag):
@@ -174,8 +175,10 @@ def find(ele, tag, nslist=[]):
 def parse_root(raw):
     """Efficiently parses the root element of an XML document.
 
+    :arg raw: XML document
     :type raw: string
     :returns: a tuple of `(tag, attributes)`, where `tag` is the (qualified) name of the element and `attributes` is a dictionary of its attributes.
+    :rtype: `tuple`
     """
     fp = StringIO(raw[:1024]) # this is a guess but start element beyond 1024 bytes would be a bit absurd
     for event, element in ET.iterparse(fp, events=('start',)):
diff --git a/ncclient/manager.py b/ncclient/manager.py
index cd8ad03..b99276c 100644
--- a/ncclient/manager.py
+++ b/ncclient/manager.py
@@ -12,36 +12,55 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+"Thin layer of abstraction around NCClient"
+
 import capabilities
 from operations import OPERATIONS
 import transport
 
-
-def ssh_connect(*args, **kwds):
+def connect_ssh(*args, **kwds):
+    """Connect to NETCONF server over SSH. See :meth:`SSHSession.connect()
+    <ncclient.transport.SSHSession.connect>` for function signature."""
     session = transport.SSHSession(capabilities.CAPABILITIES)
-    session.load_system_host_keys()
+    session.load_known_hosts()
     session.connect(*args, **kwds)
     return Manager(session)
 
-connect = ssh_connect # default session type
+#: Same as :meth:`connect_ssh`
+connect = connect_ssh
 
-#: Raise all errors
+#: Raise all :class:`~ncclient.operations.rpc.RPCError`
 RAISE_ALL = 0
-#:
+#: Only raise when *error-severity* is "error" i.e. no warnings
 RAISE_ERR = 1
-#:
+#: Don't raise any
 RAISE_NONE = 2
 
 class Manager:
 
-    "Thin layer of abstraction for the ncclient API."
+    """API for NETCONF operations. Currently only supports making synchronous
+    RPC requests.
+
+    It is also a context manager, so a :class:`Manager` instance can be used
+    with the *with* statement. The session is closed when the context ends. """
 
     def __init__(self, session):
         self._session = session
-        self._rpc_error_action = RAISE_ALL
+        self._raise = RAISE_ALL
 
     def set_rpc_error_action(self, action):
-        self._rpc_error_handling = option
+        """Specify the action to take when an *<rpc-error>* element is encountered.
+
+        :arg action: one of :attr:`RAISE_ALL`, :attr:`RAISE_ERR`, :attr:`RAISE_NONE`
+        """
+        self._raise = action
+
+    def __enter__(self):
+        return self
+
+    def __exit__(self, *args):
+        self.close()
+        return False
 
     def do(self, op, *args, **kwds):
         op = OPERATIONS[op](self._session)
@@ -55,73 +74,53 @@ class Manager:
                         raise error
         return reply
 
-    def __enter__(self):
-        pass
+    #: :see: :meth:`Get.request() <ncclient.operations.Get.request>`
+    get = lambda self, *args, **kwds: self.do('get', *args, **kwds)
 
-    def __exit__(self, *args):
-        self.close()
-        return False
+    #: :see: :meth:`GetConfig.request() <ncclient.operations.GetConfig.request>`
+    get_config = lambda self, *args, **kwds: self.do('get-config', *args, **kwds)
 
-    def locked(self, target):
-        """Returns a context manager for use with the 'with' statement.
+    #: :see: :meth:`EditConfig.request() <ncclient.operations.EditConfig.request>`
+    edit_config = lambda self, *args, **kwds: self.do('edit-config', *args, **kwds)
 
-        :arg target: name of the datastore to lock
-        :type target: `string`
-        """
-        return operations.LockContext(self._session, target)
+    #: :see: :meth:`CopyConfig.request() <ncclient.operations.CopyConfig.request>`
+    copy_config = lambda self, *args, **kwds: self.do('copy-config', *args, **kwds)
 
-    def get(self, filter=None):
-        pass
+    #: :see: :meth:`GetConfig.request() <ncclient.operations.Validate.request>`
+    validate = lambda self, *args, **kwds: self.do('validate', *args, **kwds)
 
-    def get_config(self, source, filter=None):
-        pass
+    #: :see: :meth:`Commit.request() <ncclient.operations.Commit.request>`
+    commit = lambda self, *args, **kwds: self.do('commit', *args, **kwds)
 
-    def copy_config(self, source, target):
-        pass
+    #: :see: :meth:`DiscardChanges.request() <ncclient.operations.DiscardChanges.request>`
+    discard_changes = lambda self, *args, **kwds: self.do('discard-changes', *args, **kwds)
 
-    def validate(self, source):
-        pass
-
-    def commit(self, target):
-        pass
-
-    def discard_changes(self):
-        pass
-
-    def delete_config(self, target):
-        pass
-
-    def lock(self, target):
-        pass
-
-    def unlock(self, target):
-        pass
-
-    def close_session(self):
-        pass
-
-    def kill_session(self, session_id):
-        pass
-
-    def confirmed_commit(self, timeout=None):
-        pass
-
-    def confirm(self):
-        # give confirmation
-        pass
-
-    def discard_changes(self):
-        pass
+    #: :see: :meth:`DeleteConfig.request() <ncclient.operations.DeleteConfig.request>`
+    delete_config = lambda self, *args, **kwds: self.do('delete-config', *args, **kwds)
 
+    #: :see: :meth:`Lock.request() <ncclient.operations.Lock.request>`
     lock = lambda self, *args, **kwds: self.do('lock', *args, **kwds)
 
+    #: :see: :meth:`DiscardChanges.request() <ncclient.operations.Unlock.request>`
     unlock = lambda self, *args, **kwds: self.do('unlock', *args, **kwds)
 
+    #: :see: :meth:`CloseSession.request() <ncclient.operations.CloseSession.request>`
     close_session = lambda self, *args, **kwds: self.do('close-session', *args, **kwds)
 
+    #: :see: :meth:`KillSession.request() <ncclient.operations.KillSession.request>`
     kill_session = lambda self, *args, **kwds: self.do('kill-session', *args, **kwds)
 
+    def locked(self, target):
+        """Returns a context manager for the *with* statement.
+
+        :arg target: name of the datastore to lock
+        :type target: `string`
+        :rtype: :class:`operations.LockContext`
+        """
+        return operations.LockContext(self._session, target)
+
     def close(self):
+        """Closes the NETCONF session. First does *<close-session>* RPC."""
         try: # try doing it clean
             self.close_session()
         except Exception as e:
@@ -131,16 +130,25 @@ class Manager:
 
     @property
     def session(self, session):
+        ":class:`~ncclient.transport.Session` instance"
         return self._session
 
     @property
     def client_capabilities(self):
+        ":class:`~ncclient.capabilities.Capabilities` object for client"
         return self._session._client_capabilities
 
     @property
     def server_capabilities(self):
+        ":class:`~ncclient.capabilities.Capabilities` object for server"
         return self._session._server_capabilities
 
     @property
     def session_id(self):
+        "*<session-id>* as assigned by NETCONF server"
         return self._session.id
+
+    @property
+    def connected(self):
+        "Whether currently connected to NETCONF server"
+        return self._session.connected
diff --git a/ncclient/operations/__init__.py b/ncclient/operations/__init__.py
index b9ceafb..d731223 100644
--- a/ncclient/operations/__init__.py
+++ b/ncclient/operations/__init__.py
@@ -12,10 +12,10 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-from errors import OperationError, MissingCapabilityError
+from errors import OperationError, TimeoutExpiredError, MissingCapabilityError
 from rpc import RPC, RPCReply, RPCError
 from retrieve import Get, GetConfig, GetReply
-from edit import EditConfig, CopyConfig, DeleteConfig, Validate, Commit, DiscardChanges, ConfirmedCommit
+from edit import EditConfig, CopyConfig, DeleteConfig, Validate, Commit, DiscardChanges
 from session import CloseSession, KillSession
 from lock import Lock, Unlock, LockContext
 #from subscribe import CreateSubscription
@@ -47,12 +47,14 @@ __all__ = [
     'CopyConfig',
     'Validate',
     'Commit',
-    'ConfirmedCommit'
     'DiscardChanges',
     'DeleteConfig',
     'Lock',
     'Unlock',
     'LockContext',
     'CloseSession',
-    'KillSession'
+    'KillSession',
+    'OperationError',
+    'TimeoutExpiredError',
+    'MissingCapabilityError'
 ]
diff --git a/ncclient/operations/edit.py b/ncclient/operations/edit.py
index 806f9e9..8f72211 100644
--- a/ncclient/operations/edit.py
+++ b/ncclient/operations/edit.py
@@ -18,19 +18,35 @@ from rpc import RPC
 
 import util
 
-"Operations related to configuration editing"
+"Operations related to changing device configuration"
 
 class EditConfig(RPC):
 
+    "*<edit-config>* RPC"
+
     SPEC = {'tag': 'edit-config', 'subtree': []}
 
-    def request(self, target=None, config=None, default_operation=None,
-                test_option=None, error_option=None):
-        util.one_of(target, config)
+    def request(self, target, config, default_operation=None, test_option=None,
+                error_option=None):
+        """
+        :arg target: see :ref:`source_target`
+        :type target: string
+
+        :arg config: a config element in :ref:`dtree`
+        :type config: `string` or `dict` or :class:`~xml.etree.ElementTree.Element`
+
+        :arg default_operation: optional; one of {'merge', 'replace', 'none'}
+        :type default_operation: `string`
+
+        :arg test_option: optional; one of {'stop-on-error', 'continue-on-error', 'rollback-on-error'}. Last option depends on the *:rollback-on-error* capability
+        :type test_option: string
+
+        :seealso: :ref:`return`
+        """
         spec = EditConfig.SPEC.copy()
         subtree = spec['subtree']
         subtree.append(util.store_or_url('target', target, self._assert))
-        subtree.append(content.validated_root(config, 'config'))
+        subtree.append(content.validated_element(config, ('config', content.qualify('config'))))
         if default_operation is not None:
             subtree.append({
                 'tag': 'default-operation',
@@ -51,12 +67,19 @@ class EditConfig(RPC):
                 })
         return self._request(spec)
 
-
 class DeleteConfig(RPC):
 
+    "*<delete-config>* RPC"
+
     SPEC = {'tag': 'delete-config', 'subtree': []}
 
     def request(self, target):
+        """
+        :arg target: See :ref:`source_target`
+        :type target: `string` or `dict` or :class:`~xml.etree.ElementTree.Element`
+
+        :seealso: :ref:`return`
+        """
         spec = DeleteConfig.SPEC.copy()
         spec['subtree'].append(util.store_or_url('target', target, self._assert))
         return self._request(spec)
@@ -64,9 +87,20 @@ class DeleteConfig(RPC):
 
 class CopyConfig(RPC):
 
+    "*<copy-config>* RPC"
+
     SPEC = {'tag': 'copy-config', 'subtree': []}
 
     def request(self, source, target):
+        """
+        :arg source: See :ref:`source_target`
+        :type source: `string` or `dict` or :class:`~xml.etree.ElementTree.Element`
+
+        :arg target: See :ref:`source_target`
+        :type target: `string` or `dict` or :class:`~xml.etree.ElementTree.Element`
+
+        :seealso: :ref:`return`
+        """
         spec = CopyConfig.SPEC.copy()
         spec['subtree'].append(util.store_or_url('source', source, self._assert))
         spec['subtree'].append(util.store_or_url('target', target, self._assert))
@@ -75,25 +109,36 @@ class CopyConfig(RPC):
 
 class Validate(RPC):
 
+    "*<validate>* RPC. Depends on the *:validate* capability."
+
     DEPENDS = [':validate']
 
     SPEC = {'tag': 'validate', 'subtree': []}
 
     def request(self, source):
-        # determine if source is a <config> element
+        """
+        :arg source: See :ref:`source_target`
+        :type source: `string` or `dict` or :class:`~xml.etree.ElementTree.Element`
+
+        :seealso: :ref:`return`
+        """
         spec = Validate.SPEC.copy()
         try:
             spec['subtree'].append({
                 'tag': 'source',
-                'subtree': content.validated_root(config, ('config', content.qualify('config')))
+                'subtree':
+                    content.validated_element(
+                        config, ('config', content.qualify('config')))
                 })
-        except ContentError:
+        except:
             spec['subtree'].append(util.store_or_url('source', source, self._assert))
         return self._request(spec)
 
 
 class Commit(RPC):
 
+    "*<commit>* RPC. Depends on the *:candidate* capability."
+
     DEPENDS = [':candidate']
 
     SPEC = {'tag': 'commit', 'subtree': []}
@@ -101,7 +146,19 @@ class Commit(RPC):
     def _parse_hook(self):
         pass
 
-    def request(self, confirmed=False):
+    def request(self, confirmed=False, timeout=None):
+        """
+        Requires *:confirmed-commit* capability if *confirmed* argument is
+        :const:`True`.
+
+        :arg confirmed: optional; request a confirmed commit
+        :type confirmed: `bool`
+
+        :arg timeout: specify timeout for confirmed commit
+        :type timeout: `int`
+
+        :seealso: :ref:`return`
+        """
         spec = SPEC.copy()
         if confirmed:
             self._assert(':confirmed-commit')
@@ -116,24 +173,8 @@ class Commit(RPC):
 
 class DiscardChanges(RPC):
 
+    "*<discard-changes>* RPC. Depends on the *:candidate* capability."
+
     DEPENDS = [':candidate']
 
     SPEC = {'tag': 'discard-changes'}
-
-
-class ConfirmedCommit(Commit):
-    "psuedo-op"
-
-    DEPENDS = [':candidate', ':confirmed-commit']
-
-    def request(self):
-        "Commit changes requiring that a confirm/discard follow"
-        return Commit.request(self, confirmed=True)
-
-    def confirm(self):
-        "Confirm changes"
-        return Commit.request(self, confirmed=True)
-
-    def discard(self):
-        "Discard changes"
-        return DiscardChanges(self.session, self.async, self.timeout).request()
diff --git a/ncclient/operations/errors.py b/ncclient/operations/errors.py
index bf60cd8..623abed 100644
--- a/ncclient/operations/errors.py
+++ b/ncclient/operations/errors.py
@@ -17,5 +17,8 @@ from ncclient import NCClientError
 class OperationError(NCClientError):
     pass
 
+class TimeoutExpiredError(NCClientError):
+    pass
+
 class MissingCapabilityError(NCClientError):
     pass
diff --git a/ncclient/operations/lock.py b/ncclient/operations/lock.py
index 94528ab..aa454d0 100644
--- a/ncclient/operations/lock.py
+++ b/ncclient/operations/lock.py
@@ -18,6 +18,8 @@ from rpc import RPC
 
 class Lock(RPC):
 
+    "*<lock>* RPC"
+
     SPEC = {
         'tag': 'lock',
         'subtree': {
@@ -26,14 +28,22 @@ class Lock(RPC):
         }
     }
 
-    def request(self, target, *args, **kwds):
+    def request(self, target):
+        """
+        :arg target: see :ref:`source_target`
+        :type target: string
+
+        :rtype: :ref:`return`
+        """
         spec = Lock.SPEC.copy()
         spec['subtree']['subtree']['tag'] = target
-        return self._request(spec, *args, **kwds)
+        return self._request(spec)
 
 
 class Unlock(RPC):
 
+    "*<unlock>* RPC"
+
     SPEC = {
         'tag': 'unlock',
         'subtree': {
@@ -42,14 +52,27 @@ class Unlock(RPC):
         }
     }
 
-    def request(self, target, *args, **kwds):
+    def request(self, target):
+        """
+        :arg target: see :ref:`source_target`
+        :type target: string
+
+        :rtype: :ref:`return`
+        """
         spec = Unlock.SPEC.copy()
         spec['subtree']['subtree']['tag'] = target
-        return self._request(spec, *args, **kwds)
+        return self._request(spec)
 
 
 class LockContext:
 
+    """
+    A context manager for the :class:`Lock` / :class:`Unlock` pair of RPC's.
+
+    Initialise with session instance (:class:`Session
+    <ncclient.transport.Session>`) and lock target (:ref:`source_target`)
+    """
+
     def __init__(self, session, target):
         self.session = session
         self.target = target
diff --git a/ncclient/operations/retrieve.py b/ncclient/operations/retrieve.py
index 30a69d1..0af2f8d 100644
--- a/ncclient/operations/retrieve.py
+++ b/ncclient/operations/retrieve.py
@@ -20,8 +20,8 @@ import util
 
 class GetReply(RPCReply):
 
-    """Adds attributes for the *<data>* element to :class:`RPCReply`, pertinent
-    to the *<get>* or *<get-config>* operations."""
+    """Adds attributes for the *<data>* element to :class:`RPCReply`, which
+    pertains to the :class:`Get` and :class:`GetConfig` operations."""
 
     def _parsing_hook(self, root):
         self._data = None
@@ -32,33 +32,41 @@ class GetReply(RPCReply):
 
     @property
     def data_ele(self):
-        "As an :class:`~xml.etree.ElementTree.Element`"
+        "*<data>* element as an :class:`~xml.etree.ElementTree.Element`"
         if not self._parsed:
             self.parse()
         return self._data
 
     @property
     def data_xml(self):
-        "As an XML string"
+        "*<data>* element as an XML string"
         if not self._parsed:
             self.parse()
         return content.ele2xml(self._data)
 
+    @property
+    def data_dtree(self):
+        "*<data>* element in :ref:`dtree`"
+        return content.ele2dtree(self._data)
+
+    #: Same as :attr:`data_ele`
     data = data_ele
 
 
 class Get(RPC):
 
-    "*<get>* RPC"
+    "The *<get>* RPC"
 
-    SPEC = {
-        'tag': 'get',
-        'subtree': []
-    }
+    SPEC = {'tag': 'get', 'subtree': []}
 
     REPLY_CLS = GetReply
 
     def request(self, filter=None):
+        """
+        :arg filter: optional; see :ref:`filter`
+
+        :seealso: :ref:`return`
+        """
         spec = Get.SPEC.copy()
         if filter is not None:
             spec['subtree'].append(util.build_filter(filter))
@@ -67,16 +75,20 @@ class Get(RPC):
 
 class GetConfig(RPC):
 
-    "*<get-config>* RPC"
+    "The *<get-config>* RPC"
 
-    SPEC = {
-        'tag': 'get-config',
-        'subtree': []
-    }
+    SPEC = {'tag': 'get-config', 'subtree': []}
 
     REPLY_CLS = GetReply
 
     def request(self, source, filter=None):
+        """
+        :arg source: See :ref:`source_target`
+
+        :arg filter: optional; see :ref:`filter`
+
+        :seealso: :ref:`return`
+        """
         spec = GetConfig.SPEC.copy()
         spec['subtree'].append(util.store_or_url('source', source, self._assert))
         if filter is not None:
diff --git a/ncclient/operations/rpc.py b/ncclient/operations/rpc.py
index 4c20458..11e29d2 100644
--- a/ncclient/operations/rpc.py
+++ b/ncclient/operations/rpc.py
@@ -17,10 +17,9 @@ from uuid import uuid1
 from weakref import WeakValueDictionary
 
 from ncclient import content
-from ncclient.capabilities import check
 from ncclient.transport import SessionListener
 
-from errors import OperationError
+from errors import OperationError, TimeoutExpiredError, MissingCapabilityError
 
 import logging
 logger = logging.getLogger('ncclient.operations.rpc')
@@ -29,9 +28,13 @@ logger = logging.getLogger('ncclient.operations.rpc')
 class RPCReply:
 
     """Represents an *<rpc-reply>*. Only concerns itself with whether the
-    operation was successful. Note that if the reply has not yet been parsed
-    there is a one-time parsing overhead to accessing the :attr:`ok` and
-    :attr:`error`/:attr:`errors` attributes."""
+    operation was successful.
+
+    .. note::
+        If the reply has not yet been parsed there is an implicit, one-time
+        parsing overhead to accessing the attributes defined by this class and
+        any subclasses.
+    """
 
     def __init__(self, raw):
         self._raw = raw
@@ -89,7 +92,8 @@ class RPCReply:
 
     @property
     def error(self):
-        "Short for :attr:`errors`[0], returning :const:`None` if there were no errors."
+        """Short for :attr:`errors` [0]; :const:`None` if there were no errors.
+        """
         if not self._parsed:
             self.parse()
         if self._errors:
@@ -99,7 +103,9 @@ class RPCReply:
 
     @property
     def errors(self):
-        "List of :class:`RPCError` objects. Will be empty if there were no :class:`<rpc-error>` elements in reply."
+        """`list` of :class:`RPCError` objects. Will be empty if there were no
+        *<rpc-error>* elements in reply.
+        """
         if not self._parsed:
             self.parse()
         return self._errors
@@ -225,7 +231,11 @@ class RPCReplyListener(SessionListener):
 
 class RPC(object):
 
-    "Directly corresponds to *<rpc>* requests. Handles making the request, and taking delivery of the reply."
+    """Base class for all operations.
+
+    Directly corresponds to *<rpc>* requests. Handles making the request, and
+    taking delivery of the reply.
+    """
 
     # : Subclasses can specify their dependencies on capabilities. List of URI's
     # or abbreviated names, e.g. ':writable-running'. These are verified at the
@@ -291,11 +301,12 @@ class RPC(object):
                 self._reply.parse()
                 return self._reply
             else:
-                raise ReplyTimeoutError
+                raise TimeoutExpiredError
 
     def request(self, *args, **kwds):
-        "Subclasses implement this method. Here, the operation is to be constructed as a :ref:`dtree`, and the result of :meth:`_request` returned."
-        return self._request(self.SPEC, *args, **kwds)
+        """Subclasses implement this method. Here, the operation is constructed
+        in :ref:`dtree`, and the result of :meth:`_request` returned."""
+        raise NotImplementedError
 
     def _delivery_hook(self):
         """Subclasses can implement this method. Will be called after
@@ -306,7 +317,7 @@ class RPC(object):
     def _assert(self, capability):
         """Subclasses can use this method to verify that a capability is available
         with the NETCONF server, before making a request that requires it. A
-        :class:`MissingCapabilityError` will be raised if the capability is not
+        :exc:`MissingCapabilityError` will be raised if the capability is not
         available."""
         if capability not in self._session.server_capabilities:
             raise MissingCapabilityError('Server does not support [%s]' % cap)
